﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using TEDDLL;

namespace TEDClient
{
    public partial class Form1 : Form, TEDListener
    {

        private TED TED;
        public Form1()
        {
            InitializeComponent();
        }
        public void OnTEDConnect(string ip)
        {
            if (cbxTEDs.Items.IndexOf(ip) == -1)
            {
                cbxTEDs.Invoke(new Action(() => { 
                    cbxTEDs.Items.Add(ip);
                    cbxTEDs.SelectedItem = cbxTEDs.SelectedItem == null 
                        ? cbxTEDs.Items[0] 
                        : cbxTEDs.SelectedItem;
                }));

                insertLog("TED " + ip + " conectado!");
            }
        }

        private void insertLog(string log)
        {
            txtLog.Invoke(new Action(() => {
                if (txtLog.Text.Length > 0) txtLog.AppendText("\r\n");
                txtLog.AppendText(log);
            })); 
        }

        public void OnTEDReceive(string ip, string data, int header)
        {
            insertLog("Recebido de " + ip + " " + data + " header: " + header.ToString());
        }

        private void btnDesconectar_Click(object sender, EventArgs e)
        {
            if (TED == null) return;
            TED.Stop();
            TED = null;
        }

        private void btnConectar_Click(object sender, EventArgs e)
        {
            if (TED != null) return;
            int port = 0;
            if (!Int32.TryParse(txtPorta.Text, out port)) port = 8;
            txtPorta.Text = port.ToString();
            TED = new TED(this);
            TED.Start();
        }

        private void btnBeep_Click(object sender, EventArgs e)
        {
            if (TED == null || cbxTEDs.Items.Count == 0 || cbxTEDs.SelectedItem == null) return;
            string ip = cbxTEDs.SelectedItem.ToString();
            int times = 0;
            if (!Int32.TryParse(txtBeep.Text, out times)) times = 1;
            TED.Beep(ip, times);
        }

        private void btnEnviarDisplay_Click(object sender, EventArgs e)
        {
            if (TED == null || cbxTEDs.SelectedItem == null) return;
            string ip = cbxTEDs.SelectedItem.ToString();
            TED.DisplaySend(ip, txtDisplay.Text);
        }

        private void btnLimparDisplay_Click(object sender, EventArgs e)
        {
            if (TED == null || cbxTEDs.SelectedItem == null) return;
            string ip = cbxTEDs.SelectedItem.ToString();
            TED.DisplayClear(ip);
        }

        private void btnCom1On_Click(object sender, EventArgs e)
        {
            if (TED == null || cbxTEDs.SelectedItem == null) return;
            string ip = cbxTEDs.SelectedItem.ToString();
            TED.Com1On(ip);
        }

        private void btnCom1Off_Click(object sender, EventArgs e)
        {
            if (TED == null || cbxTEDs.SelectedItem == null) return;
            string ip = cbxTEDs.SelectedItem.ToString();
            TED.Com1Off(ip);
        }

        private void btnCom1Enviar_Click(object sender, EventArgs e)
        {
            if (TED == null || cbxTEDs.SelectedItem == null) return;
            string ip = cbxTEDs.SelectedItem.ToString();
            TED.Com1Send(ip, txtCom1.Text);
        }

        private void button1_Click_2(object sender, EventArgs e)
        {
            if (TED == null || cbxTEDs.SelectedItem == null) return;
            string ip = cbxTEDs.SelectedItem.ToString();
            TED.Com2On(ip);
        }

        private void button2_Click_1(object sender, EventArgs e)
        {
            if (TED == null || cbxTEDs.SelectedItem == null) return;
            string ip = cbxTEDs.SelectedItem.ToString();
            TED.Com2Off(ip);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (TED == null || cbxTEDs.SelectedItem == null) return;
            string ip = cbxTEDs.SelectedItem.ToString();
            TED.Com2Send(ip, txtCom2.Text);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (TED == null || cbxTEDs.SelectedItem == null) return;
            string ip = cbxTEDs.SelectedItem.ToString();
            TED.HeaderOn(ip);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (TED == null || cbxTEDs.SelectedItem == null) return;
            string ip = cbxTEDs.SelectedItem.ToString();
            TED.HeaderOff(ip);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            if (TED == null || cbxTEDs.SelectedItem == null) return;
            string ip = cbxTEDs.SelectedItem.ToString();
            TED.DigitalOn(ip);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            if (TED == null || cbxTEDs.SelectedItem == null) return;
            string ip = cbxTEDs.SelectedItem.ToString();
            TED.DigitalOff(ip);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            txtLog.Clear();
        }
    }
}
